package de.unikoblenz.fgbks.base.utils.boundary.bicreater;

import de.unikoblenz.fgbks.base.utils.boundary.Boundary;
import java.util.Optional;

/**
 * The empty bi creater returns always an empty optional.
 */
public class EmptyBiCreater extends AbstractBoundaryBiCreater<Boundary> {

  private static final EmptyBiCreater instance = new EmptyBiCreater();

  private EmptyBiCreater() {
    super();
  }

  /**
   * Get the current instance of this class.
   *
   * @return the singleton instance
   */
  public static EmptyBiCreater getInstance() {
    return instance;
  }

  @Override
  public BoundaryBiCreaterType getType() {
    return null;
  }

  @Override
  public Optional<Boundary> create(Boundary b1, Boundary b2) {
    return Optional.empty();
  }
}
