package de.unikoblenz.fgbks.base.utils.boundary.checker;

import de.unikoblenz.fgbks.base.utils.boundary.Boundary;

/**
 * The checker interface. Used to check something between two boundaries, specified by the {@link
 * BoundaryCheckType}.
 *
 * @param <T> the boundary type
 */
public interface BoundaryCheck<T extends Boundary> {

  /**
   * Get the {@link BoundaryCheckType}.
   *
   * @return the {@link BoundaryCheckType}
   */
  BoundaryCheckType getType();

  /**
   * Perform the check between the two boundaries.
   *
   * @param b1 one boundary
   * @param b2 the other boundary
   * @return true, if the check return true.
   */
  boolean check(T b1, T b2);
}
