package de.unikoblenz.fgbks.base.utils.boundary.checker;

public enum BoundaryCheckType {
  /**
   * Type, that indicates, that the checker should check, if one boundary is equal to the other
   * boundary.
   */
  IS_EQUAL,
  /**
   * Type, that indicates, that the checker should check, if one boundary subsumes the other
   * boundary or the other boundary subsumes the first boundary.
   */
  IS_SUBSUMPTION,
  /**
   * Type, that indicates, that the checker should check, if one boundary subsumes the other
   * boundary.
   */
  SUBSUMES,
  /**
   * Type, that indicates, that the checker should check, if one boundary is in contact to the other
   * boundary.
   */
  IS_IN_CONTACT,
  /**
   * Type, that indicates, that the checker should check, if one boundary is not in contact to the
   * other boundary.
   */
  IS_NOT_IN_CONTACT,
  /**
   * Type, that indicates, that the checker should check, if one boundary is overlapping with the
   * other boundary.
   */
  IS_OVERLAPPING
}
