package de.unikoblenz.fgbks.base.utils.boundary.creater;

import de.unikoblenz.fgbks.base.utils.boundary.Boundary;
import java.util.Optional;

public class EmptyCreater extends AbstractBoundaryCreater<Boundary> {

  private static final EmptyCreater instance = new EmptyCreater();

  private EmptyCreater() {
    super();
  }

  /**
   * Get the current instance of this class.
   *
   * @return the singleton instance
   */
  public static EmptyCreater getInstance() {
    return instance;
  }

  @Override
  public BoundaryCreaterType getType() {
    return null;
  }

  @Override
  public Optional<Boundary> create(Boundary b) {
    return Optional.empty();
  }
}
