package de.unikoblenz.fgbks.base.value;

public abstract class AbstractIntegerValueObject<T extends AbstractIntegerValueObject<T>>
    extends AbstractNumberValueObject<T, Integer> {

  protected AbstractIntegerValueObject() {
    // for JPA
  }

  public AbstractIntegerValueObject(Integer initialValue) {
    super(initialValue);
  }

  public AbstractIntegerValueObject(String initialValue) {
    super(Integer.parseInt(initialValue));
  }

  @Override
  public Integer getValue() {
    return super.getValue();
  }

  @Override
  protected Integer getMinValue() {
    return 0;
  }

  @Override
  public T add(Integer addValue) {
    return newInstance(getValue() + addValue);
  }

  @Override
  public T subtract(Integer subtractValue) {
    return newInstance(getValue() - subtractValue);
  }

  @Override
  public T multiply(Integer multiplyValue) {
    return newInstance(getValue() * multiplyValue);
  }

  @Override
  public T divide(Integer divideValue) {
    return newInstance(getValue() / divideValue);
  }

  @Override
  public String toString() {
    return String.valueOf(getValue());
  }
}
