package de.unikoblenz.fgbks.base.value;

public abstract class AbstractOneCharStringValueObject extends AbstractStringValueObject {

  public static final int LENGTH = 1;

  protected AbstractOneCharStringValueObject() {
    // for proxying
  }

  public AbstractOneCharStringValueObject(String initialValue) {
    super(initialValue);
  }

  @Override
  protected Integer getMinLength() {
    return LENGTH;
  }

  @Override
  protected Integer getMaxLength() {
    return LENGTH;
  }

  @Override
  protected boolean handleBlanksAsNull() {
    return false;
  }

  @Override
  protected String validateAndNormalize(String newValue) {
    return super.validateAndNormalize(newValue);
  }

  protected abstract String getValidationPattern();
}
