package de.unikoblenz.fgbks.base.value;

public abstract class AbstractShortValueObject<T extends AbstractShortValueObject<T>>
    extends AbstractNumberValueObject<T, Short> {

  protected AbstractShortValueObject() {
    // for JPA
  }

  public AbstractShortValueObject(Short initialValue) {
    super(initialValue);
  }

  public AbstractShortValueObject(String initialValue) {
    super(Short.parseShort(initialValue));
  }

  @Override
  public Short getValue() {
    return super.getValue();
  }

  @Override
  protected Short getMinValue() {
    return 0;
  }

  @Override
  public T add(Short addValue) {
    return newInstance((short) (getValue() + addValue));
  }

  @Override
  public T subtract(Short subtractValue) {
    return newInstance((short) (getValue() - subtractValue));
  }

  @Override
  public T multiply(Short multiplyValue) {
    return newInstance((short) (getValue() * multiplyValue));
  }

  @Override
  public T divide(Short divideValue) {
    return newInstance((short) (getValue() / divideValue));
  }
}
